/*
 * Copyright (c) 2006
 *  Morten Slot Kristensen, rhus, Denmark.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <iostream>
#include <iomanip>
#include "matrix.hpp"
using namespace std;

int matrix::count=1;

/*
 * Constructor of a matrix
 */
matrix::matrix(int rows, int columns)
{
	matrix::rows = rows;
	matrix::columns = columns;
	array = new float[rows * columns];
	temp = 1.0;
}

matrix::matrix() {}

matrix::~matrix() {}

void matrix::set_id()
{
	id = count++;
}

/*
 * Print the matrix
 */
void matrix::print()
{
	for(int i=0; i<rows; ++i)
	{
		for(int j=0; j<columns; ++j)
		{
			cout << setw(4) << array[i*columns+j] << " ";
		}
		cout << endl;
	}
}

void matrix::set_value(int x, int y, float value)
{
	array[x*columns+y] = value;
}

void matrix::set_value_t(int x, float value)
{
	array[x] = value;
}

float matrix::get_value(int x, int y)
{
	return array[x*columns+y];	
}

int matrix::get_rows()
{
	return rows;
}

int matrix::get_columns()
{
	return columns;
}

int matrix::get_id()
{
	return id;
}

void matrix::set_temp(float num)
{
	temp = num;
}

float matrix::get_temp()
{
	return temp;
}
